unit lfen_ole_1;
interface
uses
  ComObj,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Edit_Init: TEdit;
    Label1: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    Edit_1C8_Name: TEdit;
    GroupBox1: TGroupBox;
    Panel3: TPanel;
    SpeedButton2: TSpeedButton;
    ListBox1: TListBox;
    Label_YesConnect: TLabel;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    s1C8_ole : Variant; //  1Cv8

  end;

var
  Form1: TForm1;


//  1Cv8 (COM)
function ConnectTo1C8_Application(s1cAppProgID,InitLine : string;Visible : boolean) : Variant;
//,    (HandleAny)
function YesLinkToVariant(HandleAny : Variant) : boolean;


implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin
  //
  s1C8_ole:=UnAssigned;
  Edit_1C8_Name.Text:='V8.Application';
  //Edit_Init.Text:='File=F:\1Cv8.DB\HomeLib';
  Edit_Init.Text:='File=C:\SP\1Cv8.DB\HomeLib';
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=true;
  s1C8_ole:=UnAssigned;
end;


procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  s1C8_ole:=UnAssigned;
  Label_YesConnect.Visible:=false;
  ListBox1.Items.Clear;
  //  1Cv8
  s1C8_ole:=ConnectTo1C8_Application(Trim(Edit_1C8_Name.Text),Trim(Edit_Init.Text),true);
  if YesLinkToVariant(s1C8_ole) then begin
     Label_YesConnect.Visible:=true;
  end
  else begin
     ShowMessage('');
  end;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
//    
Var
  TN_ole  : variant; //c   : .
  TN_form_ole  : variant; //c      : .

begin
  //,     1Cv8
  if YesLinkToVariant(s1C8_ole) then begin
     //    : .
     TN_ole := s1C8_ole..;
     //    
     TN_form_ole := TN_ole.();
     if YesLinkToVariant(TN_form_ole) then begin
        //  
        if TN_form_ole.() then begin
           ShowMessage('   !');
        end
        else begin
           // 
           TN_form_ole.();
        end;
     end
     else begin
        ShowMessage('     !');
     end;
  end
  else begin
     ShowMessage('     1Cv8 !');
  end;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
//      
Var
  TN_meta_ole  : variant; //c   ,   
  TN_ole  : variant; //c   : .
  TN_form_ole  : variant; //c      : .
  TN_val_ole : variant; //  
  TN_num  : integer; // ()  
  TN_name : string; //  

begin
  TN_val_ole := UnAssigned;
  //,     1Cv8
  if YesLinkToVariant(s1C8_ole) then begin
     //    : .
     TN_ole := s1C8_ole..;
     //    
     TN_form_ole := TN_ole.();
     if YesLinkToVariant(TN_form_ole) then begin
        //  .
        //     ,    
        // -     ,
        //    
        if TN_form_ole.() then begin
           ShowMessage('   !');
        end
        else begin
           //  .
           //   
           TN_val_ole := TN_form_ole.();

           if YesLinkToVariant(TN_form_ole) then begin

             //----------------------------
             //    
             // ()   
             TN_num := TN_ole.(TN_val_ole)*1;
             //c   ,   
             TN_meta_ole := s1C8_ole...;
             //   (  )
             TN_name:=Trim(TN_meta_ole..(TN_num).);
             //----------------------------

             ShowMessage(' : '+TN_name);

           end
           else begin
              ShowMessage('   !');
           end;
        end;
     end
     else begin
        ShowMessage('     !');
     end;
  end
  else begin
     ShowMessage('     1Cv8 !');
  end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
//    
Var
  TN_name : string;  //  
  TN_ole  : variant; //c   : .
  TN_meta_ole  : variant; //c   ,   
  i_Val,    // ()  
  Count_Val : integer;//-   
begin
  ListBox1.Items.Clear;

  //,     1Cv8
  if YesLinkToVariant(s1C8_ole) then begin

     //    : .
     TN_ole := s1C8_ole..;
     // -    
     Count_Val:=TN_ole.()*1;
     //ShowMessage(IntToStr(Count_Val));
     if Count_Val>0 then begin
        //       
        for i_Val:=0 to (Count_Val-1) do
         begin
           //    ,   
           TN_meta_ole := s1C8_ole...;
           //   
           TN_name:=Trim(TN_meta_ole..(i_Val).);
           //   ListBox1
           ListBox1.Items.Add(TN_name);
        end;
     end;

  end
  else begin
     ShowMessage('     1Cv8 !');
  end;
end;


function ConnectTo1C8_Application(s1cAppProgID,
                                  InitLine : string;
                                  Visible : boolean) : Variant;
//  1Cv8 (OLE)
{
s1cAppProgID -  1Cv8,   OLE Automation (  ))
   V8.Application
InitLine ( ) :
    .. :
    File=\Trade
    Usr=
    Pwd=
  -  .. :
    Srvr=Server1C ( ,     1)
    Ref=Trade (      1)
    Usr=
    Pwd=
}
//InitLine -  
//Visible -  TRUE,    1Cv8    
//  :   1Cv8,   OLE Automation
//                          Unassigned (  )
Var
  s1CResOpen : integer;
begin
  Result:=Unassigned;
  s1cAppProgID:=Trim(s1cAppProgID);
  if Length(s1cAppProgID)<=0 then s1cAppProgID:='V8.Application';
  InitLine:=Trim(InitLine);
  if Length(s1cAppProgID)>0 then begin
     // 
     Result := CreateOleObject(s1cAppProgID);
     //  
     if YesLinkToVariant(Result) then begin
        //  1Cv8
        s1CResOpen:=Result.Connect(InitLine);
        //   1Cv8
        Result.Visible:=Visible;
     end;
  end;
end;


function YesLinkToVariant(HandleAny : Variant) : boolean;
//,    (HandleAny)
begin
 Result:=FALSE;
 if not VarIsEmpty(HandleAny) then Result:=TRUE;
end;






end.






